/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the MailProperties type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MailProperties{}

// MailProperties struct for MailProperties
type MailProperties struct {
	Id                  NullableString `json:"id,omitempty"`
	MailType            NullableString `json:"mailType,omitempty"`
	IdentityId          NullableString `json:"identityId,omitempty"`
	PrimaryMailAlias    NullableString `json:"primaryMailAlias,omitempty"`
	MailAliases         []string       `json:"mailAliases,omitempty"`
	ForwardingAddress   NullableString `json:"forwardingAddress,omitempty"`
	ForwardOnly         *bool          `json:"forwardOnly,omitempty"`
	ExternalEmail       NullableString `json:"externalEmail,omitempty"`
	IdentityUpn         NullableString `json:"identityUpn,omitempty"`
	IdentityDisplayName NullableString `json:"identityDisplayName,omitempty"`
}

// NewMailProperties instantiates a new MailProperties object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMailProperties() *MailProperties {
	this := MailProperties{}
	return &this
}

// NewMailPropertiesWithDefaults instantiates a new MailProperties object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMailPropertiesWithDefaults() *MailProperties {
	this := MailProperties{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *MailProperties) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *MailProperties) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *MailProperties) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *MailProperties) UnsetId() {
	o.Id.Unset()
}

// GetMailType returns the MailType field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetMailType() string {
	if o == nil || IsNil(o.MailType.Get()) {
		var ret string
		return ret
	}
	return *o.MailType.Get()
}

// GetMailTypeOk returns a tuple with the MailType field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetMailTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.MailType.Get(), o.MailType.IsSet()
}

// HasMailType returns a boolean if a field has been set.
func (o *MailProperties) HasMailType() bool {
	if o != nil && o.MailType.IsSet() {
		return true
	}

	return false
}

// SetMailType gets a reference to the given NullableString and assigns it to the MailType field.
func (o *MailProperties) SetMailType(v string) {
	o.MailType.Set(&v)
}

// SetMailTypeNil sets the value for MailType to be an explicit nil
func (o *MailProperties) SetMailTypeNil() {
	o.MailType.Set(nil)
}

// UnsetMailType ensures that no value is present for MailType, not even an explicit nil
func (o *MailProperties) UnsetMailType() {
	o.MailType.Unset()
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityId.Get()
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityId.Get(), o.IdentityId.IsSet()
}

// HasIdentityId returns a boolean if a field has been set.
func (o *MailProperties) HasIdentityId() bool {
	if o != nil && o.IdentityId.IsSet() {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given NullableString and assigns it to the IdentityId field.
func (o *MailProperties) SetIdentityId(v string) {
	o.IdentityId.Set(&v)
}

// SetIdentityIdNil sets the value for IdentityId to be an explicit nil
func (o *MailProperties) SetIdentityIdNil() {
	o.IdentityId.Set(nil)
}

// UnsetIdentityId ensures that no value is present for IdentityId, not even an explicit nil
func (o *MailProperties) UnsetIdentityId() {
	o.IdentityId.Unset()
}

// GetPrimaryMailAlias returns the PrimaryMailAlias field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetPrimaryMailAlias() string {
	if o == nil || IsNil(o.PrimaryMailAlias.Get()) {
		var ret string
		return ret
	}
	return *o.PrimaryMailAlias.Get()
}

// GetPrimaryMailAliasOk returns a tuple with the PrimaryMailAlias field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetPrimaryMailAliasOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PrimaryMailAlias.Get(), o.PrimaryMailAlias.IsSet()
}

// HasPrimaryMailAlias returns a boolean if a field has been set.
func (o *MailProperties) HasPrimaryMailAlias() bool {
	if o != nil && o.PrimaryMailAlias.IsSet() {
		return true
	}

	return false
}

// SetPrimaryMailAlias gets a reference to the given NullableString and assigns it to the PrimaryMailAlias field.
func (o *MailProperties) SetPrimaryMailAlias(v string) {
	o.PrimaryMailAlias.Set(&v)
}

// SetPrimaryMailAliasNil sets the value for PrimaryMailAlias to be an explicit nil
func (o *MailProperties) SetPrimaryMailAliasNil() {
	o.PrimaryMailAlias.Set(nil)
}

// UnsetPrimaryMailAlias ensures that no value is present for PrimaryMailAlias, not even an explicit nil
func (o *MailProperties) UnsetPrimaryMailAlias() {
	o.PrimaryMailAlias.Unset()
}

// GetMailAliases returns the MailAliases field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetMailAliases() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.MailAliases
}

// GetMailAliasesOk returns a tuple with the MailAliases field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetMailAliasesOk() ([]string, bool) {
	if o == nil || IsNil(o.MailAliases) {
		return nil, false
	}
	return o.MailAliases, true
}

// HasMailAliases returns a boolean if a field has been set.
func (o *MailProperties) HasMailAliases() bool {
	if o != nil && !IsNil(o.MailAliases) {
		return true
	}

	return false
}

// SetMailAliases gets a reference to the given []string and assigns it to the MailAliases field.
func (o *MailProperties) SetMailAliases(v []string) {
	o.MailAliases = v
}

// GetForwardingAddress returns the ForwardingAddress field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetForwardingAddress() string {
	if o == nil || IsNil(o.ForwardingAddress.Get()) {
		var ret string
		return ret
	}
	return *o.ForwardingAddress.Get()
}

// GetForwardingAddressOk returns a tuple with the ForwardingAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetForwardingAddressOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ForwardingAddress.Get(), o.ForwardingAddress.IsSet()
}

// HasForwardingAddress returns a boolean if a field has been set.
func (o *MailProperties) HasForwardingAddress() bool {
	if o != nil && o.ForwardingAddress.IsSet() {
		return true
	}

	return false
}

// SetForwardingAddress gets a reference to the given NullableString and assigns it to the ForwardingAddress field.
func (o *MailProperties) SetForwardingAddress(v string) {
	o.ForwardingAddress.Set(&v)
}

// SetForwardingAddressNil sets the value for ForwardingAddress to be an explicit nil
func (o *MailProperties) SetForwardingAddressNil() {
	o.ForwardingAddress.Set(nil)
}

// UnsetForwardingAddress ensures that no value is present for ForwardingAddress, not even an explicit nil
func (o *MailProperties) UnsetForwardingAddress() {
	o.ForwardingAddress.Unset()
}

// GetForwardOnly returns the ForwardOnly field value if set, zero value otherwise.
func (o *MailProperties) GetForwardOnly() bool {
	if o == nil || IsNil(o.ForwardOnly) {
		var ret bool
		return ret
	}
	return *o.ForwardOnly
}

// GetForwardOnlyOk returns a tuple with the ForwardOnly field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailProperties) GetForwardOnlyOk() (*bool, bool) {
	if o == nil || IsNil(o.ForwardOnly) {
		return nil, false
	}
	return o.ForwardOnly, true
}

// HasForwardOnly returns a boolean if a field has been set.
func (o *MailProperties) HasForwardOnly() bool {
	if o != nil && !IsNil(o.ForwardOnly) {
		return true
	}

	return false
}

// SetForwardOnly gets a reference to the given bool and assigns it to the ForwardOnly field.
func (o *MailProperties) SetForwardOnly(v bool) {
	o.ForwardOnly = &v
}

// GetExternalEmail returns the ExternalEmail field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetExternalEmail() string {
	if o == nil || IsNil(o.ExternalEmail.Get()) {
		var ret string
		return ret
	}
	return *o.ExternalEmail.Get()
}

// GetExternalEmailOk returns a tuple with the ExternalEmail field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetExternalEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExternalEmail.Get(), o.ExternalEmail.IsSet()
}

// HasExternalEmail returns a boolean if a field has been set.
func (o *MailProperties) HasExternalEmail() bool {
	if o != nil && o.ExternalEmail.IsSet() {
		return true
	}

	return false
}

// SetExternalEmail gets a reference to the given NullableString and assigns it to the ExternalEmail field.
func (o *MailProperties) SetExternalEmail(v string) {
	o.ExternalEmail.Set(&v)
}

// SetExternalEmailNil sets the value for ExternalEmail to be an explicit nil
func (o *MailProperties) SetExternalEmailNil() {
	o.ExternalEmail.Set(nil)
}

// UnsetExternalEmail ensures that no value is present for ExternalEmail, not even an explicit nil
func (o *MailProperties) UnsetExternalEmail() {
	o.ExternalEmail.Unset()
}

// GetIdentityUpn returns the IdentityUpn field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetIdentityUpn() string {
	if o == nil || IsNil(o.IdentityUpn.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityUpn.Get()
}

// GetIdentityUpnOk returns a tuple with the IdentityUpn field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetIdentityUpnOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityUpn.Get(), o.IdentityUpn.IsSet()
}

// HasIdentityUpn returns a boolean if a field has been set.
func (o *MailProperties) HasIdentityUpn() bool {
	if o != nil && o.IdentityUpn.IsSet() {
		return true
	}

	return false
}

// SetIdentityUpn gets a reference to the given NullableString and assigns it to the IdentityUpn field.
func (o *MailProperties) SetIdentityUpn(v string) {
	o.IdentityUpn.Set(&v)
}

// SetIdentityUpnNil sets the value for IdentityUpn to be an explicit nil
func (o *MailProperties) SetIdentityUpnNil() {
	o.IdentityUpn.Set(nil)
}

// UnsetIdentityUpn ensures that no value is present for IdentityUpn, not even an explicit nil
func (o *MailProperties) UnsetIdentityUpn() {
	o.IdentityUpn.Unset()
}

// GetIdentityDisplayName returns the IdentityDisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailProperties) GetIdentityDisplayName() string {
	if o == nil || IsNil(o.IdentityDisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityDisplayName.Get()
}

// GetIdentityDisplayNameOk returns a tuple with the IdentityDisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailProperties) GetIdentityDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityDisplayName.Get(), o.IdentityDisplayName.IsSet()
}

// HasIdentityDisplayName returns a boolean if a field has been set.
func (o *MailProperties) HasIdentityDisplayName() bool {
	if o != nil && o.IdentityDisplayName.IsSet() {
		return true
	}

	return false
}

// SetIdentityDisplayName gets a reference to the given NullableString and assigns it to the IdentityDisplayName field.
func (o *MailProperties) SetIdentityDisplayName(v string) {
	o.IdentityDisplayName.Set(&v)
}

// SetIdentityDisplayNameNil sets the value for IdentityDisplayName to be an explicit nil
func (o *MailProperties) SetIdentityDisplayNameNil() {
	o.IdentityDisplayName.Set(nil)
}

// UnsetIdentityDisplayName ensures that no value is present for IdentityDisplayName, not even an explicit nil
func (o *MailProperties) UnsetIdentityDisplayName() {
	o.IdentityDisplayName.Unset()
}

func (o MailProperties) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MailProperties) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.MailType.IsSet() {
		toSerialize["mailType"] = o.MailType.Get()
	}
	if o.IdentityId.IsSet() {
		toSerialize["identityId"] = o.IdentityId.Get()
	}
	if o.PrimaryMailAlias.IsSet() {
		toSerialize["primaryMailAlias"] = o.PrimaryMailAlias.Get()
	}
	if o.MailAliases != nil {
		toSerialize["mailAliases"] = o.MailAliases
	}
	if o.ForwardingAddress.IsSet() {
		toSerialize["forwardingAddress"] = o.ForwardingAddress.Get()
	}
	if !IsNil(o.ForwardOnly) {
		toSerialize["forwardOnly"] = o.ForwardOnly
	}
	if o.ExternalEmail.IsSet() {
		toSerialize["externalEmail"] = o.ExternalEmail.Get()
	}
	if o.IdentityUpn.IsSet() {
		toSerialize["identityUpn"] = o.IdentityUpn.Get()
	}
	if o.IdentityDisplayName.IsSet() {
		toSerialize["identityDisplayName"] = o.IdentityDisplayName.Get()
	}
	return toSerialize, nil
}

type NullableMailProperties struct {
	value *MailProperties
	isSet bool
}

func (v NullableMailProperties) Get() *MailProperties {
	return v.value
}

func (v *NullableMailProperties) Set(val *MailProperties) {
	v.value = val
	v.isSet = true
}

func (v NullableMailProperties) IsSet() bool {
	return v.isSet
}

func (v *NullableMailProperties) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMailProperties(val *MailProperties) *NullableMailProperties {
	return &NullableMailProperties{value: val, isSet: true}
}

func (v NullableMailProperties) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMailProperties) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
